/*
 * This file was automatically generated by Apache Tiles Autotag.
 */
package org.apache.tiles.velocity.template;

import java.io.IOException;
import java.io.Writer;

import org.apache.tiles.autotag.core.runtime.ModelBody;
import org.apache.tiles.autotag.core.runtime.AutotagRuntime;
import org.apache.tiles.request.Request;
import org.apache.velocity.context.InternalContextAdapter;
import org.apache.velocity.runtime.directive.Directive;
import org.apache.velocity.runtime.parser.node.Node;

/**
 * <p>
 * <strong>Inserts the value of an attribute into the page.</strong>
 * </p>
 * <p>
 * This tag can be flexibly used to insert the value of an attribute into a
 * page. As in other usages in Tiles, every attribute can be determined to have
 * a "type", either set explicitly when it was defined, or "computed". If the
 * type is not explicit, then if the attribute value is a valid definition, it
 * will be inserted as such. Otherwise, if it begins with a "/" character, it
 * will be treated as a "template". Finally, if it has not otherwise been
 * assigned a type, it will be treated as a String and included without any
 * special handling.
 * </p>
 * 
 * <p>
 * <strong>Example : </strong>
 * </p>
 * 
 * <pre>
 * &lt;code&gt;
 *           &lt;tiles:insertAttribute name=&quot;body&quot; /&gt;
 *         &lt;/code&gt;
 * </pre>
 */
public class InsertAttributeDirective extends Directive {

    /**
     * The template model.
     */
    private org.apache.tiles.template.InsertAttributeModel model = new org.apache.tiles.template.InsertAttributeModel();

    /** {@inheritDoc} */
    @Override
    public String getName() {
        return "tiles_insertAttribute";
    }

    /** {@inheritDoc} */
    @Override
    public int getType() {
        return BLOCK;
    }

    /** {@inheritDoc} */
    @Override
    public boolean render(InternalContextAdapter context, Writer writer, Node node)
            throws IOException {
        AutotagRuntime runtime = new org.apache.tiles.request.velocity.autotag.VelocityAutotagRuntime();
        if (runtime instanceof Directive) {
            ((Directive) runtime).render(context, writer, node);
        }
        Request request = runtime.createRequest();
        ModelBody modelBody = runtime.createModelBody();
        model.execute(
            (java.lang.Boolean) runtime.getParameter("ignore", false),
            (java.lang.String) runtime.getParameter("preparer", null),
            (java.lang.String) runtime.getParameter("role", null),
            (java.lang.Object) runtime.getParameter("defaultValue", null),
            (java.lang.String) runtime.getParameter("defaultValueRole", null),
            (java.lang.String) runtime.getParameter("defaultValueType", null),
            (java.lang.String) runtime.getParameter("name", null),
            (org.apache.tiles.Attribute) runtime.getParameter("value", null),
            (java.lang.Boolean) runtime.getParameter("flush", false),
            request, modelBody
        );
        return true;
    }
}
